<?php
	// basic functions -------------------------------------------------------
	
	// setup cURL 
	$ch = curl_init();
	curl_setopt($ch, CURL_HTTP_VERSION_1_1, true);
	//curl_setopt($ch, CURLOPT_NOSIGNAL, false);	// need from timeouts
	curl_setopt($ch, CURLOPT_TIMEOUT, 30);			// quick timeout
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30);
	curl_setopt($ch, CURLOPT_DNS_CACHE_TIMEOUT, 600);	// should match set_time_limit()
	curl_setopt($ch, CURLOPT_FAILONERROR, true);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
	if (defined('PROXY_ADDRESS')) {
		curl_setopt($ch, CURLOPT_PROXY, PROXY_ADDRESS);
	}
	//curl_setopt($ch, CURLOPT_COOKIEJAR, '-');		// use this to not save cookies (not recommended when using newzbin)
	curl_setopt($ch, CURLOPT_COOKIEFILE, WEBSERVER_LOCAL_DIR . 'newsscraper_cookiejar.txt');
	curl_setopt($ch, CURLOPT_COOKIEJAR, WEBSERVER_LOCAL_DIR . 'newsscraper_cookiejar.txt');
	curl_setopt($ch, CURLOPT_ENCODING, 'gzip,deflate');
	curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.2) Gecko/20070228 Firefox/2.0.0.4');
	
	// get html page with curl
	function getPage($url, $referrer = null, $postField = null, $exitOnError = false) {
		
		//echo 'url :: <a href="' . $url . '">' . $url . '</a><br />';
		curl_setopt($GLOBALS['ch'], CURLOPT_URL, $url);
		if ($referrer !== null) {
			curl_setopt($GLOBALS['ch'], CURLOPT_REFERRER, $referrer);
		} else {
			curl_setopt($GLOBALS['ch'], CURLOPT_REFERRER, $url);
		}
		if ($postField !== null) {
			curl_setopt($GLOBALS['ch'], CURLOPT_POST, 1);
			curl_setopt($GLOBALS['ch'], CURLOPT_POSTFIELDS, $postField);
		} else {
			curl_setopt($GLOBALS['ch'], CURLOPT_POST, 0);
		}
		$retries = PAGE_RETRIES;
		do {
			$html = curl_exec($GLOBALS['ch']);
			if (isset($_GET['debug'])) {
				echo $html;
			}
			if (curl_errno($GLOBALS['ch']) == 0) {
				// no error
				return $html;
			}
			sleep(PAGE_RETRIES_WAIT);
		} while ($retries-- > 0);
		// failed to load page (halfass method)
		if ($exitOnError) {
			echo '<br /><br />unable to load page, stopping scrape...';
			exit();
		}
		return '';
	}
	
	// convert given date to a standardized format
	function standardDate($stringDate) {
		if (date("m.d.Y") == date("m.d.Y", strtotime($stringDate))) {
			// today
			return '<span class="today">' . date("m.d.Y", strtotime($stringDate)) . '</span>';
		} elseif (date("m.d.Y", strtotime("- 1 day")) == date("m.d.Y", strtotime($stringDate))) {
			// today
			return '<span class="yesterday">' . date("m.d.Y", strtotime($stringDate)) . '</span>';
		} else {
			return date("m.d.Y", strtotime($stringDate));
		}
	}
	
	
	function highlight($name, $type = OTHER) {
		if (!isset($GLOBALS['matchRegex'][$type]) || $type == OTHER) {
			return $name;
		} elseif (preg_match("/^(" . $GLOBALS['matchRegex'][$type] . ")/i", html_entity_decode($name))) {
			return '<span class="highlight">' . $name . '</span>';
		} else {
			return $name;
		}
	}
	
	/*
	function highlightPSP($name) {
		if (preg_match("/( |\.)(JAP|JPN|KOR|CHN)( |\.)/", html_entity_decode($name))) {
			return '<span class="jap">' . $name . '</span>';
		} else {
			return $name;
		}
	}
	
	function highlightXBOX($name) {
		if (preg_match("/( |\.)PAL( |\.)/", html_entity_decode($name))) {
			return '<span class="pal">' . $name . '</span>';
		} else {
			return $name;
		}
	}
	*/
	
	function highlightRating($rating) {
		if (preg_match("/^(10|9|8)\.\d$/", $rating)) {
			return '<span class="highlight">' . $rating . '</span>';
		} else {
			return $rating;
		}
	}
?>