<?php

	// setup cURL 
	define('PAGE_RETRIES', 2);				// how many times to retry getting a page if there is any error
	define('PAGE_RETRIES_WAIT', 5);			// time in seconds to wait between retries
	$ch = curl_init();
	curl_setopt($ch, CURL_HTTP_VERSION_1_1, true);
	//curl_setopt($ch, CURLOPT_NOSIGNAL, false);	// need from timeouts
	curl_setopt($ch, CURLOPT_TIMEOUT, 30);			// quick timeout
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30);
	curl_setopt($ch, CURLOPT_DNS_CACHE_TIMEOUT, 600);	// should match set_time_limit()
	curl_setopt($ch, CURLOPT_FAILONERROR, true);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
	curl_setopt($ch, CURLOPT_COOKIEJAR, '-');		// use this to not save cookies (not recommended when using newzbin)
	//curl_setopt($ch, CURLOPT_COOKIEFILE, '/tmp/cookiejar.txt');
	//curl_setopt($ch, CURLOPT_COOKIEJAR, '/tmp/cookiejar.txt');
	curl_setopt($ch, CURLOPT_ENCODING, 'gzip,deflate');
	curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.2) Gecko/20070228 Firefox/2.0.0.11');
	
	// SABnzbdPlus
	$xml = new SimpleXMLElement(getPage('http://localhost:9191/sabnzbd/api?mode=qstatus&output=xml', null, 'ma_username=aaaaaa&ma_password=bbbbbb'));
	$mbleft = ceil($xml->mbleft);
	$mb = ceil($xml->mb);
	$paused = $xml->paused;
	$kbpersec = floor($xml->kbpersec);
	$noofslots = $xml->noofslots;
	$current_left = ceil($xml->jobs->job[0]->mbleft);
	$current_total = ceil($xml->jobs->job[0]->mb);
	
/*	// old SABnzb
	
	$html = getPage('http://localhost:9191/sabnzbd/api?mode=qstatus&output=xml', null, 'ma_username=aaaaaa&ma_password=bbbbbb');
	echo $html; exit();
	$html = preg_replace("/[\t\n\r ]/", "", $html);	// trim junk
	// "mbleft": 19258.79,
	$mbleft = preg_replace("/^.*?\"mbleft\":(\d+).*$/i", "$1", $html);
	// "mb": 5093.61,
	$mb = preg_replace("/^.*?\"mb\":(\d+).*$/i", "$1", $html);
	// "paused": "False",
	$paused = preg_replace("/^.*?\"paused\":\"([^\"]+)\".*$/i", "$1", $html);
	// "kbpersec": 858.38,
	$kbpersec = preg_replace("/^.*?\"kbpersec\":(\d+).*$/i", "$1", $html);
	// "noofslots": "4",
	$noofslots = preg_replace("/^.*?\"noofslots\":\"(\d+)\".*$/i", "$1", $html);
	// { "index": 0, "unpackopts": 3, "nzo_id": "SABnzbd_nzo_nrWjEs", "filename": "msgid_2836574_fskjgfskg.nzb", "mbleft": 4463.91, "mb": 5093.61,
	$current_left = preg_replace("/^.*?{\"index\":0,[^}]+?\"mbleft\":(\d+)(?:\.\d+)?,\"mb\":(\d+)(?:\.\d+)?,.*$/i", "$1", $html);
	$current_total = preg_replace("/^.*?{\"index\":0,[^}]+?\"mbleft\":(\d+)(?:\.\d+)?,\"mb\":(\d+)(?:\.\d+)?,.*$/i", "$2", $html);
*/

	if ($mbleft >= 1000) {
		$mbleft_text = (string)round(($mbleft / 1024), 1) . 'GB';
	} else {
		$mbleft_text = $mbleft . 'MB';
	}
	if ($current_total == 0) {
		$current_percent = 'x';
	} else {
		$current_percent = (string)round((1-($current_left/$current_total))*100);
	}
	// total percent
	if ($mb == 0) {
		$total_percent = 'x';
	} else {
		$total_percent = (string)round((1-($mbleft/$mb))*100);
	}

	//echo "$mbleft | $paused | $kbpersec | $noofslots"; exit();
	
	$output = 'SAB: ';
	$code = 0;
	if ($noofslots == 0) {
		$output .= 'idle';
	} else {
		$output .= $noofslots . ' | ';
		if (($paused == 'True') && ($noofslots > 0)) {
			$code = 2;
			$output .= 'paused | ';
		} else {
			$output .= $kbpersec . 'k/s | ';
		}
		if ($noofslots == 1) {
			$output .= $current_percent . '% | ';
		} else {
			$output .= $current_percent . '/' . $total_percent . '% | ';
		}
		$output .= $mbleft_text;
	}
	//echo $output;
	
	header("Content-type: text/xml");
	echo "<whatmon><code>$code</code><text>$output</text></whatmon>";
	
	
	// -----------------------------------------------------------------------
	// get html page with curl
	function getPage($url, $referrer = null, $postField = null, $exitOnError = false) {
		
		//echo 'url :: <a href="' . $url . '">' . $url . '</a><br />';
		curl_setopt($GLOBALS['ch'], CURLOPT_URL, $url);
		if ($referrer !== null) {
			curl_setopt($GLOBALS['ch'], CURLOPT_REFERRER, $referrer);
		} else {
			curl_setopt($GLOBALS['ch'], CURLOPT_REFERRER, $url);
		}
		if ($postField !== null) {
			curl_setopt($GLOBALS['ch'], CURLOPT_POST, 1);
			curl_setopt($GLOBALS['ch'], CURLOPT_POSTFIELDS, $postField);
		} else {
			curl_setopt($GLOBALS['ch'], CURLOPT_POST, 0);
		}
		$retries = PAGE_RETRIES;
		do {
			$html = curl_exec($GLOBALS['ch']);
			if (isset($_GET['debug'])) {
				echo $html;
			}
			if (curl_errno($GLOBALS['ch']) == 0) {
				// no error
				return $html;
			}
			sleep(PAGE_RETRIES_WAIT);
		} while ($retries-- > 0);
		// failed to load page (halfass method)
		if ($exitOnError) {
			echo '<br /><br />unable to load page, stopping scrape...';
			exit();
		}
		return '';
	}

?>

